(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ww-lazy-load"] = factory();
	else
		root["ww-lazy-load"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _getElementPosition = __webpack_require__(1);

	var _setSources = __webpack_require__(6);

	var _setConfig = __webpack_require__(4);

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	var LazyLoadWW = function LazyLoadWW() {
	  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	  var config = (0, _setConfig.setConfig)(props);

	  var $els = document.querySelectorAll('.' + config.lazyClass);
	  if (!$els.length) return;

	  var wHeight = window.innerHeight;

	  if (config.placeholderSrc) [].concat(_toConsumableArray($els)).forEach(function ($el) {
	    var rect = (0, _getElementPosition.getElementPosition)($el);
	    if (rect - wHeight <= config.distanceToVisibleArea) return;
	    $el.src = config.placeholderSrc;
	  });

	  var onDocumentScroll = function onDocumentScroll() {
	    [].concat(_toConsumableArray($els)).forEach(function ($el) {
	      var rect = (0, _getElementPosition.getElementPosition)($el);
	      if (rect - wHeight > config.distanceToVisibleArea) return;

	      ///////////////   Start of loading notification   ////////////////
	      $el.classList.remove(config.lazyClass);
	      $el.classList.add(config.loadingClass);
	      ///////////////   /Start of loading notification   ///////////////

	      /////////////////////       Set sources       ////////////////////
	      var hasSource = $el.hasAttribute('data-source-mobile') || $el.hasAttribute('data-source-tablet') || $el.hasAttribute('data-source-desktop') || $el.hasAttribute('data-source-xl');

	      /*      Img sources    */
	      if (hasSource && $el.tagName.toLowerCase() === 'img') (0, _setSources.setSourcesToImg)($el, config.breakpoints);
	      /*     Video sources   */
	      else if (hasSource && $el.toLowerCase() === 'video') (0, _setSources.setSourcesToVideo)($el, config.breakpoints);
	      /////////////////////      /Set sources       ////////////////////

	      /////////////////////       Set img src       ////////////////////
	      $el.src = $el.dataset.src;
	      ////////////////////       /Set img src       ////////////////////

	      ////////////////////      Set img srcset      ////////////////////
	      var srcset = $el.dataset.srcset;
	      if (srcset) $el.srcset = srcset;
	      ////////////////////      /Set img srcset     ////////////////////


	      ////////////////   End of download notification   ////////////////
	      $el.onload = function () {
	        $el.classList.remove(config.loadingClass);
	        $el.setAttribute('class', config.loadedClass);
	      };
	      ////////////////   /End of download notification   ////////////////
	    });

	    $els = document.querySelectorAll('.' + config.lazyClass);
	    if (!$els.length) return document.removeEventListener('scroll', onDocumentScroll);
	  };

	  document.addEventListener('scroll', onDocumentScroll);
	  onDocumentScroll();
	};

	exports.default = LazyLoadWW;

/***/ }),
/* 1 */
/***/ (function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var getElementPosition = exports.getElementPosition = function getElementPosition(element) {
	  var rect = element.getBoundingClientRect();
	  return rect.top;
	};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var configInterface = exports.configInterface = {
	  lazyClass: 'string',
	  loadedClass: 'string',
	  loadingClass: 'string',

	  distanceToVisibleArea: 'number',

	  breakpoints: {
	    sm: 'number',
	    md: 'number',
	    lg: 'number'
	  },

	  placeholderSrc: 'string'
	};

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var defaultConfig = exports.defaultConfig = {
	  lazyClass: 'lazy',
	  loadedClass: 'loaded',
	  loadingClass: 'loading',

	  distanceToVisibleArea: 600,

	  breakpoints: {
	    sm: 639,
	    md: 1023,
	    lg: 1919
	  },

	  placeholderSrc: null
	};

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.setConfig = undefined;

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	var _propsValidation = __webpack_require__(5);

	var _configInterface = __webpack_require__(2);

	var _defaultConfig = __webpack_require__(3);

	var setConfig = exports.setConfig = function setConfig(props) {
	  if ((typeof props === 'undefined' ? 'undefined' : _typeof(props)) !== 'object') {
	    console.error('The props data type must be an object');
	    return _defaultConfig.defaultConfig;
	  }

	  var validProps = (0, _propsValidation.propsValidation)(props, _configInterface.configInterface);

	  for (var i in _defaultConfig.defaultConfig) {
	    if (!validProps[i]) continue;

	    if (_typeof(validProps[i]) === 'object') {
	      for (var j in _defaultConfig.defaultConfig[i]) {
	        if (!validProps[i][j]) continue;
	        _defaultConfig.defaultConfig[i][j] = validProps[i][j];
	      }
	      continue;
	    }

	    _defaultConfig.defaultConfig[i] = validProps[i];
	  }

	  return _defaultConfig.defaultConfig;
	};

/***/ }),
/* 5 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	var propsValidation = exports.propsValidation = function propsValidation(props, configInterface) {
	  for (var i in props) {
	    if (_typeof(props[i]) === 'object') {
	      props[i] = propsValidation(props[i], configInterface[i]);
	    }

	    if (_typeof(props[i]) === configInterface[i]) continue;
	    delete props[i];
	    console.error('The ' + props[i] + ' data type must be a ' + configInterface[i]);
	  }

	  return props;
	};

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.setSourcesToVideo = exports.setSourcesToImg = undefined;

	var _setSourceType = __webpack_require__(7);

	var getSources = function getSources($el) {
	  return {
	    sm: $el.dataset.sourceMobile,
	    md: $el.dataset.sourceTablet,
	    lg: $el.dataset.sourceDesktop,
	    xl: $el.dataset.sourceXl
	  };
	};

	var setMedia = function setMedia(breakpoints, sources) {
	  return {
	    sm: 'screen and (max-device-width: ' + breakpoints.sm + 'px)',
	    md: '(min-device-width: ' + (breakpoints.sm + 1) + 'px) and (max-device-width: ' + breakpoints.md + 'px)',
	    lg: sources.xl ? '(min-device-width: ' + (breakpoints.md + 1) + 'px) and (max-device-width: ' + breakpoints.lg + 'px)' : '(min-device-width: ' + (breakpoints.md + 1) + 'px)',
	    xl: '(min-device-width: ' + (breakpoints.lg + 1) + 'px)'
	  };
	};

	var setSourcesToImg = exports.setSourcesToImg = function setSourcesToImg($el, breakpoints) {
	  var $picture = $el.parentNode;
	  if ($picture.tagName.toLowerCase() !== 'picture') {
	    $picture = document.createElement('picture');
	    $el.after($picture);
	    $picture.append($el);
	  }

	  var sources = getSources($el);
	  var media = setMedia(breakpoints, sources);

	  Object.keys(sources).forEach(function (key) {
	    if (!sources[key]) return;

	    var $source = document.createElement('source');
	    $source.setAttribute('srcset', sources[key]);
	    $source.setAttribute('media', media[key]);
	    var type = (0, _setSourceType.setSourceType)(sources[key]);
	    type && $source.setAttribute('type', type);

	    $el.before($source);
	  });
	};

	var setSourcesToVideo = exports.setSourcesToVideo = function setSourcesToVideo($el, breakpoints) {
	  var sources = getSources($el);
	  var media = setMedia(breakpoints, sources);

	  Object.keys(sources).forEach(function (key) {
	    if (!sources[key]) return;
	    var $source = document.createElement('source');
	    $source.setAttribute('srcset', sources[key]);
	    $source.setAttribute('media', media[key]);
	    $el.append($source);
	  });
	};

/***/ }),
/* 7 */
/***/ (function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var setSourceType = exports.setSourceType = function setSourceType(source) {
	  var fileTypeArr = source.split('.');
	  var fileType = fileTypeArr[fileTypeArr.length - 1];
	  switch (fileType.toLowerCase()) {
	    case 'webm':
	      return 'video/webm';
	    case 'mp4':
	      return 'video/mp4';
	    case 'ogg':
	      return 'video/ogg';
	    case 'ogv':
	      return 'video/ogg';
	    case 'mov':
	      return 'video/quicktime';

	    case 'jpeg':
	      return 'image/jpeg';
	    case 'jpg':
	      return 'image/jpeg';
	    case 'jpe':
	      return 'image/jpeg';
	    case 'jif':
	      return 'image/jpeg';
	    case 'jfif':
	      return 'image/jpeg';

	    case 'png':
	      return 'image/png';
	    case 'webp':
	      return 'image/webp';
	    case 'svg':
	      return 'image/svg+xml';

	    default:
	      return null;
	  }
	};

/***/ })
/******/ ])
});
;